#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum OutputFrequencyType {
    /// Frequency in Hertz.
    #[serde(rename = "LINEAR")]
    Linear,
    /// Frequency in radians per second.
    #[serde(rename = "ANGULAR")]
    Angular,
    /// Normalized frequency, in the range [0, 0.5] for real-valued signals.
    #[serde(rename = "NORMALIZED_LINEAR")]
    NormalizedLinear,
    /// Normalized angular frequency, in the range [0, π] for real-valued signals.
    #[serde(rename = "NORMALIZED_ANGULAR")]
    NormalizedAngular,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl OutputFrequencyType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            OutputFrequencyType::Linear => "LINEAR",
            OutputFrequencyType::Angular => "ANGULAR",
            OutputFrequencyType::NormalizedLinear => "NORMALIZED_LINEAR",
            OutputFrequencyType::NormalizedAngular => "NORMALIZED_ANGULAR",
            OutputFrequencyType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for OutputFrequencyType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for OutputFrequencyType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for OutputFrequencyType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<OutputFrequencyType, conjure_object::plain::ParseEnumError> {
        match v {
            "LINEAR" => Ok(OutputFrequencyType::Linear),
            "ANGULAR" => Ok(OutputFrequencyType::Angular),
            "NORMALIZED_LINEAR" => Ok(OutputFrequencyType::NormalizedLinear),
            "NORMALIZED_ANGULAR" => Ok(OutputFrequencyType::NormalizedAngular),
            v => v.parse().map(|v| OutputFrequencyType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for OutputFrequencyType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<OutputFrequencyType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the OutputFrequencyType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
